package org.opengroup.osdu.notification.api;

import static org.junit.Assert.assertEquals;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;
import org.opengroup.osdu.notification.util.IBMTestUtils;

import com.sun.jersey.api.client.ClientResponse;

public class TestPubsubEndpointHMAC extends PubsubEndpointHMACTests {

    @BeforeClass
    public static void classSetup() throws Exception {
        PubsubEndpointHMACTests.classSetup();
    }

    @AfterClass
    public static void classTearDown() throws Exception {
    }

    @Before
    @Override
    public void setup() throws Exception {
        this.testUtils = new IBMTestUtils();
    }

    @After
    @Override
    public void tearDown() throws Exception {
        this.testUtils = null;
    }
    
    @Override
    public void should_return400_when_makingHttpRequestWithoutToken()throws Exception{
		ClientResponse response =  descriptor.run(getArg(), "");
		assertEquals(error(	response.getEntity(String.class)), 403, response.getStatus());
	}

    @Ignore
    @Test
	@Override
	public void should_return20X_when_usingCredentialsWithOpsPermission() throws Exception {
		// TODO getting SubscriptionException only on ci-cd env
		super.should_return20X_when_usingCredentialsWithOpsPermission();
	}

	@Ignore
	@Test
    @Override
	public void should_return20XResponseCode_when_makingValidHttpsRequest() throws Exception {
		// TODO getting SubscriptionException only on ci-cd env
		super.should_return20XResponseCode_when_makingValidHttpsRequest();
	}
	
	//running against tenant - 'nonexistenttenant' and entitlement throws 403 for invalid teanant
	@Override
	@Test
	public void should_return401_when_noAccessOnCustomerTenant() throws Exception {
		ClientResponse response = descriptor.runOnCustomerTenant(getArg(), getOsduTenantAdminCredentials());
		assertEquals(error(	response.getEntity(String.class)),403, response.getStatus());
	}
    
    
}